/*
	boxes1() - draws plain boxes (rectangles) - requires BGI
	boxes2() - draws nested boxes - requires BGI
	boxes3() - draws nested boxes - requires BGI
*/

#include <graphics.h>
#include <stdlib.h>
#include <conio.h>

extern	step,
	keyhit(void),
	quadrant(int,int,int,int);


int boxes1(int x1,int y1,int x2,int y2)
/* plain box */
{
  rectangle(min(x1,x2),min(y1,y2),max(x1,x2),max(y1,y2));
}


int boxes2(int x1,int y1,int x2,int y2)
/* nested boxes */
{
  int	minx=min(x1,x2),
	miny=min(y1,y2),
	maxx=max(x1,x2),
	maxy=max(y1,y2);

  switch(step)
  {
    case 1:  /* solid rectangle */
	     setfillstyle(SOLID_FILL,getcolor());
	     bar(minx,miny,maxx,maxy);
	     return(0);
    default: while((minx<=maxx)&&(miny<=maxy))
	     {
	       rectangle(minx,miny,maxx,maxy);
	       minx+=step;
	       miny+=step;
	       maxx-=step;
	       maxy-=step;
	       if(kbhit()) keyhit();
	     }
	     break;
  }
}


int boxes3(int x1,int y1,int x2,int y2)
/* nested squares converging in a corner */
{
  int	s;

  if(step==1)
    return;
  s=step;
  switch(quadrant(x1,y1,x2,y2))
  {
    case 1:  while((x1<x2)&&(y1<y2))
	     {
	       rectangle(x1,y1,x2,y2);
	       x1+=s;
	       y1+=s;
	       if(kbhit()) keyhit();
	     }
	     break;
    case 2:  while((x1>x2)&&(y1<y2))
	     {
	       rectangle(x1,y1,x2,y2);
	       x1-=s;
	       y1+=s;
	       if(kbhit()) keyhit();
	     }
	     break;
    case 3:  while((x1>x2)&&(y1>y2))
	     {
	       rectangle(x1,y1,x2,y2);
	       x1-=s;
	       y1-=s;
	       if(kbhit()) keyhit();
	     }
	     break;
    case 4:  while((x1<x2)&&(y1>y2))
	     {
	       rectangle(x1,y1,x2,y2);
	       x1+=s;
	       y1-=s;
	       if(kbhit()) keyhit();
	     }
	     break;
  }
}
