/*
	lines1() - draws a single line between prescribed points
	lines2() - draws lines from screen center & then a line
		   between the points.
	lines3() - sweeps over the entire screen, XORing all pixels
		   with the current color.  Sweeps top-to-bottom.
	lines4() - sweeps over the entire screen, XORing all pixels
		   with the current color.  Sweeps left-to-right.

	all functions require BGI graphics system
*/

#include <graphics.h>
#include <stdlib.h>
#include <conio.h>

extern	xc, yc, writemode, restart,
	keyhit(void);


int lines1(int x1,int y1,int x2,int y2)
{
  line(x1,y1,x2,y2);
}


int lines2(int x1,int y1,int x2,int y2)
{
  line(x1,y1,x2,y2);
  line(x1,y1,xc,yc);
  line(x2,y2,xc,yc);
}


int lines3(int x1, int y1, int x2, int y2)
{
  int   i,
	di=1+random(3),
	midy=(y1+y2)>>1;

  for(i=0;i<=midy;i+=di)
  {
    line(x1,midy+i,x2,midy+i);
    line(x1,midy-i,x2,midy-i);
    if(kbhit())
      keyhit();
  }
  setwritemode(writemode);
  restart=1;
}


int lines4(int x1, int y1, int x2, int y2)
{
  int   i,
	di=1+random(3),
	midx=(x1+x2)>>1;

  /*  setwritemode(XOR_PUT); */
  while(kbhit())
    getch();
  for(i=0;i<=midx;i+=di)
  {
    line(midx+i,y1,midx+i,y2);
    line(midx-i,y1,midx-i,y2);
    if(kbhit())
      keyhit();
  }
  setwritemode(writemode);
  restart=1;
}


int lines5(int x1, int y1, int x2, int y2)
{
  int   i,
	di=1+random(3),
	dy1=(y1>y2) ? -2 : 2,
	dy2=-dy1,
	midx=(x1+x2)>>1;

  setwritemode(XOR_PUT);
  while(kbhit())
    getch();
  for(i=0;i<=midx;i+=di)
  {
    line(midx+i,y1,midx+i,y2);
    line(midx-i,y1,midx-i,y2);
    y1+=dy1;
    y2+=dy2;
    if(kbhit())
      keyhit();
  }
  setwritemode(writemode);
  restart=1;
}