#define PROGNAME	"Randy"
#define	VERSION		"Ver 1.0"
#define RELEASE		45
#define AUTHOR		"G.J.Pateman"
#define DATE		"Created: February 13, 1991"
#define TIME		"9:46 PM EST"
#define BORDER		YELLOW
#define CHKYBD		if(kbhit()) keyhit()		/* shorthand */
#define FLUSHKYBD	while(kbhit()) getch()		/* shorthand */


#include <conio.h>
#include <ctype.h>
#include <dos.h>
#include <graphics.h>
#include <math.h>
#include <stdio.h>
#include <stdlib.h>
#include <time.h>
#include <string.h>


/******************************  internal protos  ***************************/

currenttime(int);
drawmainwindow(void);
drawshape(int,int,int,int);
drawsidewindow(void);
gotodos(void);
helpwindow(void);
initgraphics(void);
keyhit(void);
newfill(int);
restorescrn(void);
setup(void);
storescrn(void);
intro(void);


/******************************  external protos  ***************************/

extern	clearwindow(int,int,int,int,int,int);
extern	beepme(int,int);
extern	bichrome(int,int);
extern	gprintf(int xloc, int yloc, char *fmt, ... );
extern	isvga(void);
extern	overscan(int);
extern	peep(void);
extern	quadrant(int,int,int,int);
extern	randompalette(void);
extern	savepic(int,int,int,int,char *);
extern	screenon(void);
extern	screenoff(void);
extern	shiftpal(int);
extern	twocolor(void);
extern	bar1(int,int,int,int);
extern	bar2(int,int,int,int);
extern	bows2(int,int,int,int);
extern	bows3(int,int,int,int);
extern	bows4(int,int,int,int);
extern	boxes1(int,int,int,int);
extern	boxes2(int,int,int,int);
extern	boxes3(int,int,int,int);
extern	butterfly1(int,int,int,int);
extern	circles1(int,int,int,int);
extern	circles2(int,int,int,int,float);
extern	circles3(int,int,int,int,float);
extern	curve1(int,int,int,int);
extern	ekses1(int,int,int,int);
extern	ekses2(int,int,int,int);
extern	ellipses1(int,int,int,int);
extern	ellipses2(int,int,int,int);
extern	ellipses3(int,int,int,int);
extern	ellipses4(int,int,int,int);
extern	ellipses5(int,int,int,int);
extern	ellipses6(int,int,int,int);
extern	ellipses7(int,int,int,int);
extern	ellipses8(int,int,int,int);
extern	fans1(int,int,int,int);
extern	frame1(void);
extern	frame2(void);
extern	houses1(int,int,int,int);
extern	houses2(int,int,int,int);
extern	houses3(int,int,int,int);
extern	houses4(int,int,int,int);
extern	lines1(int,int,int,int);
extern	lines2(int,int,int,int);
extern	lines3(int,int,int,int);
extern	lines4(int,int,int,int);
extern	lines5(int,int,int,int);
extern	poly1(int,int,int,int);
extern	stars1(int,int,int,int,float);
extern	streaks1(int,int,int,int);
extern	streaks2(int,int,int);
extern	streaks3(int,int,int);
extern  tile(int,int,int,int,int,int);
extern	vee1(int,int,int,int);
extern	wings1(int,int,int,int);


/************************  globals ******************************************/

struct text_info	ti1;		/* Parameters of DOS text screen  */
struct palettetype	pal1;		/* Default palette */
unsigned char		*textscrn;	/* DOS screen held here */

float	randfloat;			/* random float value for functions */
int     debug=0,			/* 0=disable all debugging code */
	maxshapes=45,			/* # of available shapes */
	defaultshape=20,		/* Start up shape if none specified */
	select=0,			/* locks in a shape (if nonzero) */
	shape,				/* Current shape # */
	dshape=0,			/* 1=ahead one shape, -1=back one */
	step,				/* between repeated shapes */
	symmetry=4,			/* octo/quad/bilateral symmetry (!) */
	clearflag=0,			/* do clearviewport() after shape */
	inhelp=0,			/* disables help screen while in it */
	paused=0,			/* toggles pause */
	swleft,swtop,swright,swbottom,	/* coords of side window */
	mwleft,mwtop,mwright,mwbottom,	/* coords of main window */
	scleft,sctop,scright,scbottom,	/* coords of screen */
	x1,x2,y1,y2,			/* coords of chosen points */
	xc,yc,				/* coordinates of screen center */
	maxcolor,			/* # of available colors */
	writemode=0,			/* 0=overwrite, 1=XOR */
	repeats,			/* # of times to repeat at (x,y) */
	restart=0,			/* abort further calls to drawshape */
	graphicsmode=VGAHI;		/* 640 X 480 X 16-color mode */



/************************  functions  ***************************************/


bombout(int errorlevel)	/* describes reason for aborting program */
{
  if(errorlevel)
     beepme(500,100);
  switch(errorlevel)
  {
    case 0: if(debug)
	    {
	      printf("shape          =    %d\n",shape);
	      printf("maxshapes      =    %d\n",maxshapes);
	      printf("default shape  =    %d\n",defaultshape);
	      printf("randfloat      =    %f\n",randfloat);
	      printf("step           =    %d\n",step);
	      printf("select         =    %d\n",select);
	      printf("symmetry       =    %d\n",symmetry);
	      printf("maxcolor       =    %d\n",maxcolor);
	      printf("writemode      =    %d\n",writemode);
	      printf("repeats        =    %d\n",repeats);
	      printf("vid mode       =    %Xh\n",graphicsmode);
	      printf("(x1,y1)        =    (%d,%d)\n",x1,y1);
	      printf("(x2,y2)        =    (%d,%d)\n",x2,y2);
	      printf("(xc,yc)        =    (%d,%d)\n",xc,yc);
	    }
	    break;
    case 1: printf("initgraph() error: %s\n", grapherrormsg(graphresult()));
	    break;
    case 2: printf("Could not allocate enough memory for text screen\n");
	    break;
    case 3: printf("Could not copy screen text to allocated memory\n");
	    break;
    case 4: printf("registerbgidriver() failed for EGAVGA_driver\n");
	    break;
    case 5: printf("registerbgifont() failed for gothic_font\n");
	    break;
    case 6: printf("Sorry, this doesn't look like a VGA system to me!\n");
	    break;
  }
  exit(errorlevel);
}


initgraphics() /* Switch to the highest resolution video mode supported */
{
  int	Driver=DETECT;

  initgraph(&Driver, &graphicsmode, "");
  if(graphresult())
  {
    closegraph();
    bombout(1);
  }
}


drawshape(x1,y1,x2,y2) /* selects a graphic shape */
{
  switch(shape)
  {
    case  1:	bar1(x1,y1,x2,y2);				break;
    case  2:	bows2(x1,y1,x2,y2);				break;
    case  3:	boxes1(x1,y1,x2,y2);				break;
    case  4:	boxes2(x1,y1,x2,y2);				break;
    case  5:	bows3(x1,y1,x2,y2);				break;
    case  6:	bows4(x1,y1,x2,y2);				break;
    case  7:	boxes3(x1,y1,x2,y2);				break;
    case  8:	butterfly1(x1,y1,x2,y2);			break;
    case  9:	circles1(x1,y1,x2,y2);				break;
    case 10:	circles2(x1,y1,x2,y2,randfloat);		break;
    case 11:	circles3(x1,y1,x2,y2,randfloat);		break;
    case 12:	curve1(x1,y1,x2,y2);				break;
    case 13:	ellipses1(x1,y1,x2,y2);				break;
    case 14:	ellipses2(x1,y1,x2,y2);				break;
    case 15:	ellipses3(x1,y1,x2,y2);				break;
    case 16:	ellipses4(x1,y1,x2,y2);				break;
    case 17:	ellipses5(x1,y1,x2,y2);				break;
    case 18:	ellipses6(x1,y1,x2,y2);				break;
    case 19:	ellipses7(x1,y1,x2,y2);				break;
    case 20:	ellipses8(x1,y1,x2,y2);				break;
    case 21:	ekses1(x1,y1,x2,y2);				break;
    case 22:	ekses2(x1,y1,x2,y2);				break;
    case 23:	frame1();					break;
    case 24:	frame2();					break;
    case 25:	fans1(x1,y1,x2,y2);				break;
    case 26:	houses1(x1,y1,x2,y2);				break;
    case 27:	houses2(x1,y1,x2,y2);				break;
    case 28:	houses3(x1,y1,x2,y2);				break;
    case 29:	houses4(x1,y1,x2,y2);				break;
    case 31:	lines1(x1,y1,x2,y2);				break;
    case 32:	lines2(x1,y1,x2,y2);				break;
    case 33:    lines3(mwleft-1,mwtop,mwright,mwbottom);	break;
    case 34:    lines4(mwleft-1,mwtop,mwright,mwbottom);	break;
    case 35:    lines5(mwleft,mwtop,mwright,mwbottom);		break;
    case 36:	poly1(x2,y1,x2,y2);				break;
    case 37:	stars1(x1,y1,x2,y2,randfloat);			break;
    case 38:	streaks1(x1,y1,x2,y2);				break;
    case 39:	streaks2(x1,y1,x2);				break;
    case 30:	streaks3(x1,y1,y2);				break;
    case 40:	vee1(x1,y1,x2,y2);				break;
    case 41:	wings1(x1,y1,x2,y2);				break;
    case 42:	bar2(x1,y1,x2,y2);				break;
    case 43:    tile(mwleft,mwtop,mwright,mwbottom,9,step%5);	break;
    case 44:    tile(mwleft,mwtop,mwright,mwbottom,7,step%5);	break;
    case 45:    tile(mwleft,mwtop,mwright,mwbottom,5,step%5);	break;
  }
}


storescrn() /* Save DOS screen before doing graphics */
{
  gettextinfo(&ti1);		/* Store parameters of text screen in ti1 */
  /* Allocate memory for text screen or exit */
  textscrn=(unsigned char *)malloc(2*ti1.screenwidth*ti1.screenheight);
  if(textscrn==NULL)
    bombout(2);
  /* Store text screen contents in textscrn */
  if(gettext(ti1.winleft,ti1.wintop,ti1.winright,ti1.winbottom,textscrn)==0)
    bombout(3);
}


restorescrn() /* Restore the saved DOS screen before returning to DOS */
{
  textmode(ti1.currmode);
  window(ti1.winleft,ti1.wintop,ti1.winright,ti1.winbottom);
  textattr(ti1.attribute);
  gotoxy(ti1.curx,ti1.cury);
  puttext(ti1.winleft,ti1.wintop,ti1.winright,ti1.winbottom,textscrn);
}


helpwindow() /* pop up a help window w/summary of key functions */
{
  struct viewporttype	v;
  unsigned char *image_buf;
  int   left=40,
	top=40,
	right=left+200,
	bottom=top+325,
	col=getcolor(),
	m=15;

  inhelp=1;
  getviewsettings(&v);
  image_buf=(unsigned char *)malloc(imagesize(left,top,right,bottom));
  getimage(left,top,right,bottom,image_buf);	/* save image under window */
  setviewport(left+1,top+1,right-1,bottom-1,1);
  setcolor(BORDER);
  clearviewport();
  rectangle(2,2,right-left-4,bottom-top-4);
  outtextxy(m+10,15,"Randy's Help Window");
  line(2,35,right-left-4,35);
  outtextxy(m,45,"0      no symmetry");
  outtextxy(m,60,"2,4,8  n-way symmetry");
  outtextxy(m,75,"A      Ahead 1 shape");
  outtextxy(m,90,"B      Back 1 shape");
  outtextxy(m,105,"C      Clear window");
  outtextxy(m,120,"D      Default colors");
  outtextxy(m,135,"H      Help window");
  outtextxy(m,150,"L      Lock in shape");	/* lock in current shape */
  outtextxy(m,165,"M      Mix up colors");	/* random palette */
  outtextxy(m,180,"O      Pick one shape");	/* lock in a random shape */
  outtextxy(m,195,"P      Pause/restart");
  outtextxy(m,210,"R      Random shapes");	/* used if non-random now */
  outtextxy(m,225,"S      Shell to DOS");	/* used if non-random now */
  outtextxy(m,240,"T      Two-color mode");	/* 2-color random palette */
  outtextxy(m,255,"W      XOR Write mode");
  outtextxy(m,270,"+,-    shift colors");	/* shift palette up/down */
  outtextxy(m,285,"!      toggle debug");
  outtextxy(m,305,"   Q,X,ESC to quit");
  /* do these actions until ESC/Q/X is pressed */
  do
  {
    FLUSHKYBD;
    while(!kbhit())   ;
    CHKYBD;
  } while(inhelp);
  FLUSHKYBD;
  setviewport(v.left,v.top,v.right,v.bottom,v.clip);
  putimage(left,top,image_buf,COPY_PUT);	/* restore image underneath */
  free(image_buf);				/* return RAM to pool */
  setcolor(col);
}


keyhit() /* take action based on which key was pressed */
{
  char c;

  do
  {
    switch(c=getch())
    {
      case '!': debug=!debug;
		break;
      case 'a':
      case 'A': dshape=1;
		break;
      case 'b':
      case 'B': dshape=-1;
		break;
      case 'c':
      case 'C':	clearflag=1;
		inhelp=0;
		break;
      case 'd':
      case 'D':	setallpalette(&pal1);
		break;
      case 'f':
      case 'F': savepic(mwleft+1,mwtop+1,mwright-1,mwbottom-1,"RANDY.PIC");
		beepme(300,200);
		break;
      case 'h':
      case 'H': if(inhelp)
                  inhelp=0;
                else
		  helpwindow();
		break;
      case '0':
      case '2':
      case '4':
      case '8': symmetry=c-'0';
		break;
      case 'l':
      case 'L': select=shape;
		break;
      case 'm':
      case 'M':	randompalette();
		break;
      case 'o':
      case 'O': dshape=2;
		break;
      case 'p':
      case 'P':	paused=!paused;
		break;
      case 'r':
      case 'R':	select=0;
		break;
      case 's':
      case 'S': gotodos();
		restart=1;
		break;
      case 't':
      case 'T':	twocolor();
		break;
      case 'w':
      case 'W': writemode=!writemode;
		break;
      case '+':	shiftpal(1);
		break;
      case '-':	shiftpal(-1);
		break;
      case 0x1B:		/* ESC key */
      case 'q':
      case 'Q': if(inhelp)
		{
		  inhelp=0;
		  return;
		}
		else
		{
		  FLUSHKYBD;
		  setallpalette(&pal1);
		  closegraph();
		  restorescrn();
		  bombout(0);
		}
		break;
      case 'x':
      case 'X':	if(inhelp)
		{
		  inhelp=0;
		  return;
		}
		else
		  bombout(0);
		break;
      default:  peep();
		FLUSHKYBD;
		break;
    }
  } while(paused);	/* loop until un-paused */
}


drawsidewindow()
{
  rectangle(swleft,swtop,swright,swbottom);
  setviewport(swleft,swtop,swright,swbottom,1);
  setfillstyle(SLASH_FILL,BLUE);
  floodfill(5,5,BORDER);
  settextstyle(GOTHIC_FONT, HORIZ_DIR, 6);
  outtextxy(12,10,PROGNAME);
  settextstyle(DEFAULT_FONT, HORIZ_DIR, 1);
  outtextxy(47,80,VERSION);
  outtextxy(31,100,AUTHOR);
  currenttime(1);/* forces currenttime() to display */
  outtextxy(35,450,"ESC to quit");
  outtextxy(39,465,"H for help");
}


drawmainwindow()
{
  setviewport(mwleft,mwtop,mwright,mwbottom,1);	/* graphics window */
  setcolor(1+random(maxcolor-1));	/* draw with any color but black */
  overscan(BLUE);			/* border around main window */
}


setup()	/* init graphics, blank screen, do windows, etc */
{
  if(registerbgidriver(EGAVGA_driver)<0)
    bombout(4);
  if(registerbgifont(gothic_font)<0)
    bombout(5);
  storescrn();				/* save DOS screen for exit */
  initgraphics();
  maxcolor=getmaxcolor();
  scleft=0;
  sctop=0;
  scright=getmaxx();
  scbottom=getmaxy();
  if(!debug)
    intro();				/* opening screen */
  getpalette(&pal1);			/* store default palette */
  randomize();				/* assure randomness */
  swleft=scbottom+1;
  swtop=sctop;
  swright=scright;
  swbottom=scbottom;
  setcolor(BORDER);
  screenoff();				/* turn screen off while drawing */
  setlinestyle(SOLID_LINE,0,NORM_WIDTH);
  rectangle(scleft,sctop,scright,scbottom);
  drawsidewindow();
  mwleft=scleft+1;
  mwtop=sctop+1;
  mwbottom=scbottom-1;
  mwright=mwbottom+1;			/* square window for symmetry */
  yc=xc=(mwright-mwleft)>>1;
  drawmainwindow();
  FLUSHKYBD;
  screenon();
}


newfill(int n) /* sets fill style based on 'n' */
{
  switch(n)
  {
    case 1:  setfillstyle(EMPTY_FILL,getcolor());	break;
    case 2:  setfillstyle(LINE_FILL,getcolor());	break;
    case 3:  setfillstyle(HATCH_FILL,getcolor());	break;
    case 4:  setfillstyle(XHATCH_FILL,getcolor());	break;
    case 5:  setfillstyle(INTERLEAVE_FILL,getcolor());	break;
    case 6:  setfillstyle(WIDE_DOT_FILL,getcolor());	break;
    case 7:  setfillstyle(CLOSE_DOT_FILL,getcolor());	break;
    default: setfillstyle(SOLID_FILL,getcolor());	break;
  }
}


intro()
{
  struct palettetype	p;
  int	colornum=2,
	i;

  screenoff();
  setcolor(YELLOW);
  setlinestyle(SOLID_LINE,0,THICK_WIDTH);
  rectangle(scleft,sctop,scright,scbottom);
  setlinestyle(SOLID_LINE,0,NORM_WIDTH);
  rectangle(scleft+6,sctop+6,scright-6,scbottom-6);
  setfillstyle(BKSLASH_FILL,BLUE);
  floodfill(15,15,YELLOW);

  setcolor(BLACK);
  setusercharsize(6,1,6,1);
  settextstyle(GOTHIC_FONT, HORIZ_DIR, USER_CHAR_SIZE);
  for(i=0;i<8;i++)
    outtextxy(70+i,25+i,"Randy");
  setcolor(YELLOW);
  outtextxy(70+i,25+i,"Randy");

  settextstyle(SMALL_FONT, HORIZ_DIR, 5);
  outtextxy(130,270,"A random VGA graphics generator by G.J.Pateman");
  outtextxy(15,459,DATE);
  outtextxy(567,459,VERSION);

  settextstyle(GOTHIC_FONT, HORIZ_DIR, 2);
  /* flash prompt in 2 colors until keypressed */
  setcolor(colornum);
  outtextxy(265,320,"Press a key!");
  FLUSHKYBD;
  screenon();
  while(!kbhit())
  {
    getpalette(&p);
    p.colors[colornum]=(p.colors[colornum]==LIGHTBLUE)?LIGHTCYAN:LIGHTBLUE;
    setallpalette(&p);
    delay(200);
  }
  screenoff();
  cleardevice();
  screenon();
}


currenttime(int force)	/* show current time in graphics mode */
{
  time_t	t;
  static time_t	oldt;
  int		currentcolor=getcolor();
  char		timestr[17]="                ";

  time(&t);
  if(!force)            /* check against oldt only if force==0 */
    if(t<(oldt+60))	/* return if previous call was less than 1 min ago */
      return;
  if(oldt)
  {
    setcolor(BLACK);
    strncpy(timestr,ctime(&oldt),16);
    gprintf(14,120,"%s",timestr);
  }
  setcolor(BORDER);
  strncpy(timestr,ctime(&t),16);
  gprintf(14,120,"%s",timestr);
  setcolor(currentcolor);
  oldt=t;	/* for next time thru */
}


gotodos()	/* shell to DOS temporarily (should change PROMPT!) */
{
  int i;

  setwritemode(COPY_PUT);
  setcolor(BLACK);
  for(i=yc-5;i<=yc+11;i++)
    line(xc-148,i,xc+150,i);
  setcolor(WHITE);
  rectangle(xc-149,yc-6,xc+151,yc+12);
  gprintf(xc-140,yc,"Ready to shell to DOS - Press a key");
  getch();
  restorecrtmode();		/* text mode */
  system("COMMAND.COM");	/* shell */
  setgraphmode(graphicsmode);	/* graphics mode */
  screenoff();
  setcolor(BORDER);
  rectangle(scleft,sctop,scright,scbottom);
  drawsidewindow();
  drawmainwindow();
  setwritemode(writemode);
  screenon();
}


main(int argc, char *argv[])
{
  if(!isvga())
    bombout(6);
  if(argc)
    select=atoi(argv[1]);
  if((select>maxshapes)||(select<0))	/* invalid shape selected */
    select=0;				/* random shapes instead */
  shape=select?select:defaultshape;	/* shape = selected || default */
  setup();				/* init graphics, windows, etc */
  while(1)
  {
    x1=random(mwright);
    y1=random(mwbottom);
    do {
      x2=random(mwright);
      y2=random(mwbottom);
    } while(hypot((x1-x2),(y1-y2))<10);	/* min distance between = 10 */

    repeats=1+random(6);
    while(repeats--)
    {
      CHKYBD;
      step=1+random(10);
      randfloat=0.001+random(300)/100.0;	/* between 0.001 & 2.999... */
      switch(symmetry)
      {
	case 8: drawshape(y1,x1,y2,x2);
		if(restart)
		  break;
		drawshape(mwbottom-y1,x1,mwbottom-y2,x2);
		if(restart)
		  break;
		drawshape(y1,mwright-x1,y2,mwright-x2);
		if(restart)
		  break;
		drawshape(mwbottom-y1,mwright-x1,mwbottom-y2,mwright-x2);
		if(restart)
		  break;
	case 4:	drawshape(mwright-x1,mwbottom-y1,mwright-x2,mwbottom-y2);
		if(restart)
		  break;
		drawshape(x1,mwbottom-y1,x2,mwbottom-y2);
		if(restart)
		  break;
	case 2:	drawshape(mwright-x1,y1,mwright-x2,y2);
		if(restart)
		  break;
	case 0:	drawshape(x1,y1,x2,y2);
      }
      restart=0;
      setviewport(swleft,swtop,swright,swbottom,1);
      currenttime(0);
      setviewport(mwleft,mwtop,mwright,mwbottom,1);
      switch(dshape)
      {
	case -1: /* back 1 shape w/wraparound */
		 if(select==1)
		   select=maxshapes;
		 else
		   --select;
		 shape=select;
		 break;
	case 1:  /* ahead 1 shape w/wraparound */
		 if(select==maxshapes)
		   select=1;
		 else
		   ++select;
		 shape=select;
		 break;
	case 2:  /* choose a shape at random & lock on it */
		 select=1+random(maxshapes-1);
		 shape=select;
		 break;
      }
      dshape=0; /* reset flag for next round */
      if(select==0)
	shape=1+random(maxshapes);
      if(clearflag)
	clearwindow(-1,-1,mwright+1,mwbottom+1,-1,0);
      else
	setcolor(random(maxcolor));
      setwritemode(writemode);
    }
  }
}
