/*
	streaks1() - draws wide streaks of color at 45-degree angles
	streaks2() - draws wide horizontal streaks of color
	streaks3() - draws wide vertical streaks of color
*/

#include <graphics.h>
#include <stdlib.h>
#include <conio.h>

extern	step,
	keyhit(void);


int streaks1(int x1,int y1,int x2,int y2)
{
  int	xstep,
	ystep,
	s=1+step%3;

  xstep=(x1<x2)?s:-s;
  ystep=(y1<y2)?s:-s;
  while((max(x1,x2)-min(x1,x2)>=s)&&(max(y1,y2)-min(y1,y2)>=s))
  {
    circle(x1,y1,step);
    x1+=xstep;
    y1+=ystep;
    if(kbhit())
      keyhit();
  }
  circle(x1,y1,step);
}


int streaks2(int x1,int y1,int x2)
{
  int	x,
	s=1+step%3;

  if(abs(x1-x2)<10)	/* minimum distance between x1 & x2 = 10 */
    return;
  if(x1<x2)
    for(x=x1;x<=x2;x+=s)
    {
      circle(x,y1,step);
      if(kbhit())
	keyhit();
    }
  else /* x1>x2 */
    for(x=x1;x>=x2;x-=s)
    {
      circle(x,y1,step);
      if(kbhit())
	keyhit();
    }
}


int streaks3(int x1,int y1,int y2)
{
  int	y,
	s=1+step%3;

  if(abs(y1-y2)<10)
    return;
  if(y1<y2)
    for(y=y1;y<=y2;y+=s)
    {
      circle(x1,y,step);
      if(kbhit())
	keyhit();
    }
  else /* y1>y2 */
    for(y=y1;y>=y2;y-=s)
    {
      circle(x1,y,step);
      if(kbhit())
	keyhit();
    }
}
